Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoTreeSimplifier.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoTreeSimplifier.cpp	(revision 998)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoTreeSimplifier.cpp	(revision 1007)
@@ -1070,50 +1127,490 @@
 
 	//incremento el numero de hojas
-	counth++;
-	activas--;
-	return (counth-1);//porque lo he incrementado en la linea de antes
-}
-
-//--------------------------------------------------------------------------------------------------------------------------------
-// ESCRIBE EL mIndex EN EL MESH DE SALIDA
-//--------------------------------------------------------------------------------------------------------------------------------
-void TreeSimplifier::EscribeMesh(int idMeshLeaves) 
-{
-	// Calcular el número de indices después de simplificar
-	long int tamIndex	=	activas * 6; // Cada hoja tiene 6 índices
-
-	//	2006-02-21.
-	float			percent;
-	long	int	update;
-	
+	countLeaves++;
+	activeLeaves--;
+	return (countLeaves-1);//porque lo he incrementado en la linea de antes
+}
+
+void TreeSimplifier::BuildOutputMesh(int idMeshLeaves) 
+{
+	// Calculate the resulting index count after simplifying
+	long int tamIndex	=	activeLeaves * 6; // Each leaf has got 6 indices
+
 	delete [] mesh->mSubMesh[idMeshLeaves].mIndex;
 	mesh->mSubMesh[idMeshLeaves].mIndexCount=tamIndex;
 	mesh->mSubMesh[idMeshLeaves].mIndex=new Geometry::Index[tamIndex];
 
-	// Recorrer las hojas, comprobar las que están activas y copiar los índices al mesh.
-	Geometry::Index indice=0;
-
-	//	2006-02-21.
-	update	=	counth	/ 10;
-	percent	=	1;
-	
-	for (long j=0; j<counth;j++)
-	{
-		//	2006-02-21
-		if (mUPB	&&	((j % update) == 0))
-		{
-			mUPB(percent);
-		}
+	// Iterate through all active leaves and dump them to the final mesh
+	Geometry::Index index=0;
+
+	int update_each	= countLeaves / 10;
+	
+	for (long j=0; j<countLeaves;j++)
+	{
+		static int ticks_since_last_update = 0;
+		if (mUPB && ticks_since_last_update>=update_each)
+		{
+			ticks_since_last_update=0;
+			mUPB(1);
+		}
+		ticks_since_last_update++;
 		
-		if ( Hojasa[j].existe == true) // si la hoja aun existe
-		{
-			mesh->mSubMesh[idMeshLeaves].mIndex[indice]=Hojasa[j].Vert_Hoja[0];
-			mesh->mSubMesh[idMeshLeaves].mIndex[indice+1]=Hojasa[j].Vert_Hoja[1];
-			mesh->mSubMesh[idMeshLeaves].mIndex[indice+2]=Hojasa[j].Vert_Hoja[2];
-			mesh->mSubMesh[idMeshLeaves].mIndex[indice+3]=Hojasa[j].Vert_Hoja[2];
-			mesh->mSubMesh[idMeshLeaves].mIndex[indice+4]=Hojasa[j].Vert_Hoja[1];
-			mesh->mSubMesh[idMeshLeaves].mIndex[indice+5]=Hojasa[j].Vert_Hoja[3];
-			indice=indice+6;
-		}
-	}
-}
+		if (Leaves[j].existe)
+		{
+//			if (index<6)
+//			{
+				mesh->mSubMesh[idMeshLeaves].mIndex[index]=Leaves[j].Vert_Hoja[0];
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+1]=Leaves[j].Vert_Hoja[1];
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+2]=Leaves[j].Vert_Hoja[2];
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+3]=Leaves[j].Vert_Hoja[2];
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+4]=Leaves[j].Vert_Hoja[1];
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+5]=Leaves[j].Vert_Hoja[3];
+/*			}
+			else
+			{
+				mesh->mSubMesh[idMeshLeaves].mIndex[index]=0;
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+1]=0;
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+2]=0;
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+3]=0;
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+4]=0;
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+5]=0;
+			}*/
+			index=index+6;
+		}
+	}
+}
+
+LeafOctree* TreeSimplifier::CreateLeafOctree(int deep)
+{
+	LeafOctree *leafoctree = new LeafOctree;
+	leafoctree->parent=NULL;
+	leafoctree->left = Vertex[0][0];
+	leafoctree->right = Vertex[0][0];
+	leafoctree->bottom = Vertex[0][1];
+	leafoctree->top = Vertex[0][1];
+	leafoctree->front = Vertex[0][2];
+	leafoctree->back = Vertex[0][2];
+
+	// calcualte the limits of the octree
+	for (int i=0; i<vertex_count; i++)
+	{
+		if (leafoctree->left>Vertex[i][0])
+			leafoctree->left=Vertex[i][0];
+		if (leafoctree->right<Vertex[i][0])
+			leafoctree->right=Vertex[i][0];
+		if (leafoctree->bottom>Vertex[i][1])
+			leafoctree->bottom=Vertex[i][1];
+		if (leafoctree->top<Vertex[i][1])
+			leafoctree->top=Vertex[i][1];
+		if (leafoctree->front>Vertex[i][2])
+			leafoctree->front=Vertex[i][2];
+		if (leafoctree->back<Vertex[i][2])
+			leafoctree->back=Vertex[i][2];
+	}
+
+	// setup the initial leaves buffer
+	leafoctree->leaves.clear();
+	octree_owning_leaf=new LeafOctree*[countLeaves*2]; // *2 to reserve memory for all simplified leaves
+	for (int i=0; i<countLeaves; i++)
+	{
+		leafoctree->leaves.push_back(i);
+		octree_owning_leaf[i] = leafoctree;
+	}
+
+	// generate the octree given an arbitrary depth
+	RecursiveCreateLeafOctree(leafoctree,deep);
+
+	// fill the octree
+	RecursiveFillOctreeWithLeaves(leafoctree);
+
+	return leafoctree;
+}
+
+void TreeSimplifier::RecursiveCreateLeafOctree(LeafOctree *parent, int deep)
+{
+	for (int i=0; i<8; i++)
+	{
+		parent->children[i] = NULL;
+		if (deep>0)
+		{
+			LeafOctree *child = parent->children[i] = new LeafOctree;
+
+			child->parent = parent;
+			switch(i)
+			{
+			case 0: 
+				child->left=parent->left; 
+				child->right=(parent->left+parent->right)*0.5f;
+				child->bottom=(parent->bottom+parent->top)*0.5f; 
+				child->top=parent->top;
+				child->front=parent->front;
+				child->back=(parent->front+parent->back)*0.5f; break;
+			case 1: 
+				child->left=(parent->left+parent->right)*0.5f; 
+				child->right=parent->right;
+				child->bottom=(parent->bottom+parent->top)*0.5f; 
+				child->top=parent->top;
+				child->front=parent->front;
+				child->back=(parent->front+parent->back)*0.5f; break;
+			case 2: 
+				child->left=parent->left;
+				child->right=(parent->left+parent->right)*0.5f;
+				child->bottom=parent->bottom;
+				child->top=(parent->bottom+parent->top)*0.5f;
+				child->front=parent->front;
+				child->back=(parent->front+parent->back)*0.5f; break;
+			case 3: 
+				child->left=(parent->left+parent->right)*0.5f;
+				child->right=parent->right;
+				child->bottom=parent->bottom;
+				child->top=(parent->bottom+parent->top)*0.5f;
+				child->front=parent->front;
+				child->back=(parent->front+parent->back)*0.5f; break;
+			case 4: 
+				child->left=parent->left; 
+				child->right=(parent->left+parent->right)*0.5f;
+				child->bottom=(parent->bottom+parent->top)*0.5f; 
+				child->top=parent->top;
+				child->back=parent->back;
+				child->front=(parent->front+parent->back)*0.5f; break;
+			case 5: 
+				child->left=(parent->left+parent->right)*0.5f; 
+				child->right=parent->right;
+				child->bottom=(parent->bottom+parent->top)*0.5f; 
+				child->top=parent->top;
+				child->back=parent->back;
+				child->front=(parent->front+parent->back)*0.5f; break;
+			case 6: 
+				child->left=parent->left;
+				child->right=(parent->left+parent->right)*0.5f;
+				child->bottom=parent->bottom;
+				child->top=(parent->bottom+parent->top)*0.5f;
+				child->back=parent->back;
+				child->front=(parent->front+parent->back)*0.5f; break;
+			case 7: 
+				child->left=(parent->left+parent->right)*0.5f;
+				child->right=parent->right;
+				child->bottom=parent->bottom;
+				child->top=(parent->bottom+parent->top)*0.5f;
+				child->back=parent->back;
+				child->front=(parent->front+parent->back)*0.5f; break;
+			}
+			RecursiveCreateLeafOctree(parent->children[i],deep-1);
+		}
+	}
+
+}
+
+void TreeSimplifier::RecursiveFillOctreeWithLeaves(LeafOctree *o)
+{   
+	for (int i=0; i<8; i++)
+	{
+		LeafOctree *child = o->children[i];
+		if (child)
+		{
+			for (std::vector<int>::iterator it=o->leaves.begin(); it!=o->leaves.end(); )
+			{
+				int idleaf = *it;
+				int idv0 = Leaves[idleaf].Vert_Hoja[0];
+				int idv1 = Leaves[idleaf].Vert_Hoja[1];
+				int idv2 = Leaves[idleaf].Vert_Hoja[2];
+				int idv3 = Leaves[idleaf].Vert_Hoja[3];
+
+				float * v0 = Vertex[idv0];
+				float * v1 = Vertex[idv1];
+				float * v2 = Vertex[idv2];
+				float * v3 = Vertex[idv3];
+
+				// if the leaf fits completely inside a child, the child owns it
+				if (child->PointInsideOctree(v0[0],v0[1],v0[2]) &&
+					child->PointInsideOctree(v1[0],v1[1],v1[2]) &&
+					child->PointInsideOctree(v2[0],v2[1],v2[2]) &&
+					child->PointInsideOctree(v3[0],v3[1],v3[2]))
+				{
+					child->leaves.push_back(idleaf);
+					it = o->leaves.erase(it);
+					octree_owning_leaf[idleaf] = child;
+				}
+				else
+					it++; 
+			}
+			// recurse all valid children
+			RecursiveFillOctreeWithLeaves(o->children[i]);
+		}
+	}
+}
+
+void TreeSimplifier::SetCriteriaOptimized(float diam)
+{
+	float coptmp2, coptmp, distmp2, distmp, criteriatmp;
+	int i, j, nleavesi, nleavesj;
+
+	int update_each	= countLeaves / 20;
+	
+	for ( i=0; i<countLeaves;i++)
+	{
+		static int ticks_since_last_update = 0;
+		if (mUPB && ticks_since_last_update>=update_each)
+		{
+			ticks_since_last_update=0;
+			mUPB(1);
+		}
+		ticks_since_last_update++;
+		
+		if (Leaves[i].existe == true)
+		{
+			Leaves[i].criterio = 1000000.0f;
+			nleavesi = int(Leaves[i].Cuantas_hojas);
+ 			float area_leaf_i = CalculateLeafArea(Leaves[i])/diam;
+
+			// Use only the leaves which belong the the same octree node as leaf i or to its parents		
+			int visit_parents = VISIT_PARENTS_DEEP;
+			for (LeafOctree *octreenode = octree_owning_leaf[i]; octreenode; octreenode=octreenode->parent, visit_parents--)
+			{
+				for (std::vector<int>::iterator it=octreenode->leaves.begin(); it!=octreenode->leaves.end(); it++)
+				{
+					j = *it;
+//				for (j=0; j<countLeaves; j++)
+//				{
+					if (j!=i && Leaves[j].existe)
+					{
+						nleavesj = int(Leaves[j].Cuantas_hojas);
+
+	//					if ( abs((nleavesi - nleavesj)) < 2)
+	//					{							
+							coptmp2 = Leaves[i].Coplanaridad(Leaves[j]);
+							coptmp = 1 - coptmp2;
+
+							//distmp2 = HausdorffOptimized( Leaves[i], Leaves[j]); 
+							distmp2 = DistanceFromCenters(Leaves[i], Leaves[j]); 
+							distmp = distmp2 / diam;
+
+							//criteriatmp = (( K1 * distmp * distmp ) + (K2 * coptmp * distmp))/ (K1 + K2);
+							criteriatmp = distmp;
+							// select the lowest
+							criteriatmp *= CalculateLeafArea(Leaves[j])/diam + area_leaf_i;
+							criteriatmp *= Leaves[j].Cuantas_hojas + Leaves[i].Cuantas_hojas;
+							if (Leaves[i].criterio > criteriatmp)
+							{
+								Leaves[i].criterio = criteriatmp;
+								Leaves[i].hoja_crit = j;
+							}
+		//				}
+					}
+				}				
+			}
+		}
+	}
+}
+
+
+void TreeSimplifier::SetCriteria2Optimized(float diam, long int newleaf)
+{
+	float  coptmp2, coptmp, distmp2, distmp, criteriatmp;
+	int i, j, nleavesi, nleavesj;
+	
+	for (i = 0; i < countLeaves; i++)
+	{
+		if (Leaves[i].existe && i!=newleaf)
+		{	
+ 			float area_leaf_i = CalculateLeafArea(Leaves[i])/diam;
+			nleavesi = int(Leaves[i].Cuantas_hojas);
+			if ( Leaves[Leaves[i].hoja_crit].existe == false)
+			{
+				Leaves[i].criterio = 1000000.0f;
+
+				int visit_parents = VISIT_PARENTS_DEEP;
+				for (LeafOctree *octreenode = octree_owning_leaf[i]; octreenode; octreenode=octreenode->parent, visit_parents--)
+				{
+					for (std::vector<int>::iterator it=octreenode->leaves.begin(); it!=octreenode->leaves.end(); it++)
+					{
+						j = *it;
+	//			for (j=0; j<countLeaves; j++)
+	//			{
+						if (j!=i && Leaves[j].existe)
+						{
+							nleavesj = int(Leaves[j].Cuantas_hojas);
+
+//							if ( abs((nleavesi - nleavesj)) < 2)
+//							{
+								coptmp2 = Leaves[i].Coplanaridad(Leaves[j]); 
+								coptmp = 1 - coptmp2;	
+							
+							
+								//distmp2 = HausdorffOptimized( Leaves[i],  Leaves[j]); 
+								distmp2 = DistanceFromCenters( Leaves[i], Leaves[j]); 
+								distmp = distmp2 / diam;
+
+								criteriatmp = (( K1 * distmp * distmp ) + (K2 * coptmp * distmp))/ (K1 + K2);
+								criteriatmp *= CalculateLeafArea(Leaves[j])/diam + area_leaf_i;
+								criteriatmp *= Leaves[j].Cuantas_hojas + Leaves[i].Cuantas_hojas;
+								
+								// select the leaf with the lowest criteria
+								if (Leaves[i].criterio > criteriatmp) 
+								{
+									Leaves[i].criterio = criteriatmp;
+									Leaves[i].hoja_crit = j;
+								}
+						//	}
+						}
+					}
+				}
+			}
+			else
+			{ 
+				nleavesj = int(Leaves[newleaf].Cuantas_hojas);
+
+//				if ( abs((nleavesi - nleavesj)) < 2)
+//				{
+					coptmp2 = Leaves[i].Coplanaridad(Leaves[newleaf]); 
+					coptmp = 1 - coptmp2;
+
+					//distmp2 = HausdorffOptimized( Leaves[i], Leaves[newleaf]); 
+					distmp2 = DistanceFromCenters( Leaves[i], Leaves[newleaf]); 
+					distmp = distmp2 / diam;
+					
+					criteriatmp = (( K1 * distmp * distmp ) + (K2 * coptmp * distmp))/ (K1 + K2);
+					criteriatmp *= CalculateLeafArea(Leaves[newleaf])/diam + area_leaf_i;
+					criteriatmp *= Leaves[newleaf].Cuantas_hojas + Leaves[i].Cuantas_hojas;
+					
+					if (Leaves[i].criterio > criteriatmp) 
+					{	
+						Leaves[i].criterio = criteriatmp;
+						Leaves[i].hoja_crit = newleaf;
+					}
+//				}
+			}
+		}
+	}
+}
+
+
+LeafOctree *TreeSimplifier::GetMinOctreeNodeForLeaf(LeafOctree *start, const Hoja &leaf)
+{
+	int idv0 = leaf.Vert_Hoja[0];
+	int idv1 = leaf.Vert_Hoja[1];
+	int idv2 = leaf.Vert_Hoja[2];
+	int idv3 = leaf.Vert_Hoja[3];
+
+	float * v0 = Vertex[idv0];
+	float * v1 = Vertex[idv1];
+	float * v2 = Vertex[idv2];
+	float * v3 = Vertex[idv3];
+
+	if (start->PointInsideOctree(v0[0],v0[1],v0[2]) &&
+		start->PointInsideOctree(v1[0],v1[1],v1[2]) &&
+		start->PointInsideOctree(v2[0],v2[1],v2[2]) &&
+		start->PointInsideOctree(v3[0],v3[1],v3[2]))
+	{
+		return start;
+	}
+
+	for (int i=0; i<8; i++)
+		if (start->children[i])
+		{
+			LeafOctree *selectedNode = GetMinOctreeNodeForLeaf(start->children[i],leaf);
+			if (selectedNode)
+				return selectedNode;
+		}
+
+	return NULL;
+}
+
+float TreeSimplifier::DistanceFromCenters(const Hoja &leaf1, const Hoja &leaf2) const
+{
+	float onex, oney, onez;
+	float twox, twoy, twoz;
+	float threex, threey, threez;
+	float fourx, foury, fourz;
+	float x1, y1, z1;
+	float x2, y2, z2;
+	float x3, y3, z3;
+	float x4, y4, z4;
+
+	onex   = Vertex[leaf1.Vert_Hoja[0]][0]; oney   = Vertex[leaf1.Vert_Hoja[0]][1]; onez   = Vertex[leaf1.Vert_Hoja[0]][2];
+	twox   = Vertex[leaf1.Vert_Hoja[1]][0]; twoy   = Vertex[leaf1.Vert_Hoja[1]][1]; twoz   = Vertex[leaf1.Vert_Hoja[1]][2];
+	threex = Vertex[leaf1.Vert_Hoja[2]][0]; threey = Vertex[leaf1.Vert_Hoja[2]][1]; threez = Vertex[leaf1.Vert_Hoja[2]][2];
+	fourx  = Vertex[leaf1.Vert_Hoja[3]][0]; foury  = Vertex[leaf1.Vert_Hoja[3]][1]; fourz  = Vertex[leaf1.Vert_Hoja[3]][2];
+
+	float center1x = (onex + twox + threex + fourx)*0.25f;
+	float center1y = (oney + twoy + threey + foury)*0.25f;
+	float center1z = (onez + twoz + threez + fourz)*0.25f;
+
+	x1 = Vertex[leaf2.Vert_Hoja[0]][0]; y1 = Vertex[leaf2.Vert_Hoja[0]][1]; z1 = Vertex[leaf2.Vert_Hoja[0]][2];
+	x2 = Vertex[leaf2.Vert_Hoja[1]][0]; y2 = Vertex[leaf2.Vert_Hoja[1]][1]; z2 = Vertex[leaf2.Vert_Hoja[1]][2];
+	x3 = Vertex[leaf2.Vert_Hoja[2]][0]; y3 = Vertex[leaf2.Vert_Hoja[2]][1]; z3 = Vertex[leaf2.Vert_Hoja[2]][2];
+	x4 = Vertex[leaf2.Vert_Hoja[3]][0]; y4 = Vertex[leaf2.Vert_Hoja[3]][1]; z4 = Vertex[leaf2.Vert_Hoja[3]][2];
+
+	float center2x = (x1 + x2 + x3 + x4)*0.25f;
+	float center2y = (y1 + y2 + y3 + y4)*0.25f;
+	float center2z = (z1 + z2 + z3 + z4)*0.25f;
+
+	return distan(center1x,center1y,center1z,center2x,center2y,center2z);
+}
+
+
+bool TreeSimplifier::PruneOctree(LeafOctree *octree)
+{
+	if (octree->HasChildren())
+	{
+		for (int i=0; i<8; i++)
+			if (octree->children[i])
+				if (PruneOctree(octree->children[i])) // if child was pruned, nullify it
+					octree->children[i]=NULL;			
+	}
+	else
+	{
+		if (octree->parent)
+		{
+			for (std::vector<int>::iterator it=octree->leaves.begin(); it!=octree->leaves.end(); it++)
+			{
+				int idleaf = *it;
+				octree->parent->leaves.push_back(idleaf);
+				octree_owning_leaf[idleaf] = octree->parent;
+			}
+			return true;
+		}
+	}
+	return false;
+}
+
+void TreeSimplifier::CrossProduct(const float *v1, const float *v2, float *res) const
+{
+	res[0] = v1[1]*v2[2] - v1[2]*v2[1];
+	res[1] = v1[2]*v2[0] - v1[0]*v2[2];
+	res[2] = v1[0]*v2[1] - v1[1]*v2[0];
+}
+
+float TreeSimplifier::SquaredModule(const float *v) const
+{
+	return (v[0]*v[0] + v[1]*v[1] + v[2]*v[2]);
+}
+
+
+float TreeSimplifier::CalculateLeafArea(Hoja &leaf) const
+{
+	int idv0 = leaf.Vert_Hoja[0];
+	int idv1 = leaf.Vert_Hoja[1];
+	int idv2 = leaf.Vert_Hoja[2];
+	int idv3 = leaf.Vert_Hoja[3];
+
+	float * v0 = Vertex[idv0];
+	float * v1 = Vertex[idv1];
+	float * v2 = Vertex[idv2];
+	float * v3 = Vertex[idv3];
+
+	float v1v0[3] = {v1[0]-v0[0],v1[1]-v0[1],v1[2]-v0[2]};
+	float v2v0[3] = {v2[0]-v0[0],v2[1]-v0[1],v2[2]-v0[2]};
+	float v2v1[3] = {v2[0]-v1[0],v2[1]-v1[1],v2[2]-v1[2]};
+	float v3v1[3] = {v3[0]-v1[0],v3[1]-v1[1],v3[2]-v1[2]};
+	
+	float cross1[3], cross2[3];
+
+	CrossProduct(v1v0,v2v0,cross1);
+	CrossProduct(v2v1,v3v1,cross2);
+
+	float mod1 = SquaredModule(cross1);
+	float mod2 = SquaredModule(cross2);
+
+	return mod1*0.5f + mod2*0.5f;
+}
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/GTGeometry.vcproj
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/GTGeometry.vcproj	(revision 980)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/GTGeometry.vcproj	(revision 1007)
@@ -363,5 +363,5 @@
 			</File>
 			<File
-				RelativePath=".\src\libs\auxiliar.h">
+				RelativePath=".\include\auxiliar.h">
 			</File>
 			<File
@@ -375,5 +375,5 @@
 			</File>
 			<File
-				RelativePath=".\src\libs\GeoBase.h">
+				RelativePath=".\include\GeoBase.h">
 			</File>
 			<File
Index: GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshViewUI.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshViewUI.cpp	(revision 998)
+++ GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshViewUI.cpp	(revision 1007)
@@ -24,4 +24,7 @@
 	//	Deactive Lod tree visualization.
 	geoMeshView->deactiveLodTree();
+
+	geoMeshView->resetTextures();
+	BuildLoadTextureSubMeshMenu();
 
 	//	Repaint the window.
@@ -919,7 +922,4 @@
 			//	Show title.
 			mProcessTitle->label("Visualize LodTrees");
-
-			// set the submesh with triangle lists as the leaves submesh
-			geoMeshView->setLeavesSubMesh(geoMeshView->findLeavesSubMesh());
 
 			//	Show the Visulize LodTree panel.
@@ -1790,5 +1790,5 @@
 		for(int i=0; i<mGeoMesh->mSubMeshCount;i++)
 		{
-			char *cadena=new char[12];
+			char *cadena=new char[256];
 
 			if (geoMeshView->getLeavesSubMesh() >= 0)
@@ -2103,16 +2103,16 @@
     else
     {
-        // Simplificar hasta un número de vértices.
+        //	Simplificar hasta un número de vértices.
         uint32 v    =    (uint32)mMeshReduction->fvalue();
 
-        // Simplifica el geomesh -> Parámetro es un factor LOD [0,1].
+        //	Simplifica el geomesh -> Parámetro es un factor LOD [0,1].
         mMeshSimplifier->Simplify(v);
 
-        //    Deletes the previous mesh.
+        //	Deletes the previous mesh.
         delete mUndoMesh;
 
         mUndoMesh    =    new Mesh();
 
-        //    Sets the undo mesh.
+        //	Sets the undo mesh.
         *mUndoMesh    =    *mGeoMesh;
 
@@ -2121,5 +2121,5 @@
         mGeoMesh    =    mMeshSimplifier->GetMesh();
 
-        //    Visualize the mesh.
+        //	Visualize the mesh.
         geoMeshView->setMesh(mGeoMesh);
     }
@@ -2127,5 +2127,4 @@
     return    true;
 }
-
 
 //---------------------------------------------------------------------------
@@ -2382,6 +2381,5 @@
 
 	//	Sets the slider range.
-	mLodStripSlider->range(lodStripsLib->MaxLod(),
-										lodStripsLib->MinLod());
+	mLodStripSlider->range(lodStripsLib->MinLod(),lodStripsLib->MaxLod());
 
 	//	Pass to geomeshview the lod strips object.
@@ -2389,5 +2387,5 @@
 	
 	//	Puts the slider in the max position.
-	mLodStripSlider->value(lodStripsLib->MinLod());
+	//mLodStripSlider->value(lodStripsLib->MinLod());
 }
 
@@ -2521,7 +2519,4 @@
 			//	Restore simplification state.
 			simplificationState	=	NO_SIMPLIFICATION;
-
-			geoMeshView->resetTextures();
-			BuildLoadTextureSubMeshMenu();
 		}
 	}
Index: GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoTool.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoTool.cpp	(revision 980)
+++ GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoTool.cpp	(revision 1007)
@@ -4,4 +4,5 @@
 #endif
 
+#include <malloc.h>
 #include "GeoMeshViewUI.h"
 
@@ -15,4 +16,6 @@
 int main(int argc, char **argv)
 {
+	_set_sbh_threshold(1016);
+
 	interface	=	new GeoMeshViewUI(incrementa);
 	
